static void show( int *arr, int row, int col ) {
   int r, c;
   printf( "матрица : %d x %d [ %d ]\n",
           row, col, row * col );
   for( r = 0; r < row; r++ ) {
      for( c = 0; c < col; c++ )
         printf( "%3d", arr[ r * col + c ] );
      printf( "\n" );
   }
}

static void transpa( int *arr, int *row, int *col ) {
   int r, c;
   int wrk[ *row * *col ];    // массив с динамической размерностью
   for( r = 0; r < *row; r++ )
      for( c = 0; c < *col; c++ ) {
         int i1 = r * *col + c,
             i2 = c * *row + r;
         wrk[ i2 ] = arr[ i1 ];
      }
   for( r = 0; r < *row * *col; r++ ) {
      arr[ r ] = wrk[ r ];
   }
   r = *row;
   *row = *col;
   *col = r;
}

#define COL 5
#define ROW 2

void testv2( void ) {        // динамические массивы VLA (C99)
   int c[ ROW ][ COL ] = {
          { 1, 2, 3, 4, 5 },
          { 2, 3, 4, 5, 6 }
       },
       col = COL, row = ROW;
   printf( "транспонирование не квадратной матрицы\n" ); 
   show( (int*)c, row, col );
   transpa( (int*)c, &row, &col );
   show( (int*)c, row, col );
}
