#include <stdlib.h>
#include <string.h>
#include <stdio.h>

inline char simb( unsigned val ) {
   return val < 10 ? '0' + val : 'A' + val - 10;
}

unsigned input( char *msg ) {
   int i;
   unsigned ret = 0;
   printf( "%s", msg );
   fflush( stdout );
   if( ( i = scanf( "%u", &ret ) ) <= 0 || ret <= 0 ) {
      printf( "ошибка ввода\n" );
      exit( 1 );
   }
   return ret;
}

void show( int n, unsigned ost, unsigned arr[] ) { // только для отладки:
   unsigned i;
   printf( "%3u -> {[%d]: ", ost, n );
   for( i = 0; i < n && arr[ i ] >= 0; i++ ) 
      printf( "%u ", arr[ i ] );
   printf( "}\n" );   
};

int main( int argc, char **argv ) {
   int i, j, debug = ( argc > 1 && 
                       ( 0 == strcmp( argv[ 1 ], "-v" ) ||
                         0 == strcmp( argv[ 1 ], "debug" ) ) );
   while( 1 ) {
      unsigned metr, ch, zn;
      metr = input( "система счисления: " );
      ch = input( "числитель: " );
      zn = input( "знаменатель: " );
      if( ch >= zn ) {
         printf( "должнв быть правльная дробь!\n" );
         continue;
      }
      char *sval = (char*)calloc( zn + 1, sizeof( char ) );
      unsigned *list = (unsigned*)calloc( zn, sizeof( unsigned ) );
      for( i = 0; i < zn; i++ ) list[ i ] = -1;
      unsigned ost = ch;                    // остаток от деления
      for( i = 0; ; i++, ost *= metr ) {
         if( i > 0 ) sval[ i - 1 ] = simb( ost / zn );
         ost %= zn;
         if( debug ) show( i, ost, list );
         if( 0 == ost ) break;
         for( j = 0; j < i; j++ ) 
            if( ost == list[ j ] ) break;   // найден совпадающий остаток
         if( i == 0 || j == i ) 
            list[ i ] = ost;
         else {
            ost = i - j;
            break; 
         }
      }
      sval[ i ] = '\0';
      free( list );
      char *sres = (char*)calloc( strlen( sval ) + 4, sizeof( char ) );
      strcpy( sres, "0." );
      i = strlen( sval ) - ost;
      strncpy( sres + strlen( sres ), sval, i );
      if( ost > 0 ) {
         strcat( sres, "(" );
         strcat( sres, sval + i );
         strcat( sres, ")" );
      }
      printf( "длина периода %u : %u / %u = %s\n", ost, ch, zn, sres );
      free( sval );
      free( sres );
   }
   return 0;
}
