#include <stdlib.h>
#include <string.h>
#include <stdio.h>

inline char simb( unsigned val ) {
   return val < 10 ? '0' + val : 'A' + val - 10;
}

unsigned input( char *msg ) {
   int i;
   unsigned ret = 0;
   printf( "%s", msg );
   fflush( stdout );
   if( ( i = scanf( "%u", &ret ) ) <= 0 || ret <= 0 ) {
      printf( "ошибка ввода\n" );
      exit( 1 );
   }
   return ret;
}

void show( unsigned ost, 
           int arr[], unsigned size ) {   // только для отладки
   unsigned i;
   printf( "%3u -> { ", ost );
   for( i = 0; i < size; i++ )
      if( arr[ i ] < 0 ) printf( ". " );
      else printf( "%u ", arr[ i ] );
   printf( "}\n" );
}

int main( int argc, char **argv ) {
   int debug = argc > 1;
   unsigned i;
   while( 1 ) {
      unsigned metr, ch, zn;
      metr = input( "система счисления: " );
      ch = input( "числитель: " );
      zn = input( "знаменатель: " );
      if( ch >= zn ) {
         printf( "должнв быть правльная дробь!\n" );
         continue;
      }
      char *sval = (char*)calloc( zn + 1, sizeof( char ) );
      unsigned ost = ch;                    // остаток от деления
      int *list = (int*)calloc( zn, sizeof( int ) );
      for( i = 0; i < zn; i++ ) list[ i ] = -1;
      for( i = 0; ; i++, ost *= metr ) {
         if( i > 0 ) sval[ i - 1 ] = simb( ost / zn );
         ost %= zn;
         if( debug ) show( ost, list, zn ); 
         if( 0 == ost ) break;
         if( list[ ost ] < 0 ) 
            list[ ost ] = i;
         else {
            ost = i - list[ ost ];
            break; 
         }
      };
      sval[ i ] = '\0';
      free( list );
//printf( "длина периода %u : %u / %u = %s\n", ost, ch, zn, sval );
      char *sres = (char*)calloc( strlen( sval ) + 4, sizeof( char ) );
      strcpy( sres, "0." );
      i = strlen( sval ) - ost;
      strncpy( sres + strlen( sres ), sval, i );
      if( ost > 0 ) {
         strcat( sres, "(" );
         strcat( sres, sval + i );
         strcat( sres, ")" );
      }
      printf( "длина периода %u : %u / %u = %s\n", ost, ch, zn, sres );
      free( sval );
      free( sres );
   } 
   return 0;
}
